<?php
/**
* @version      2.5.3 19.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopOrder extends JTable {
    
    var $order_id = null;
    var $order_number = null;
    var $user_id = null;
    var $order_total = null;
    var $order_subtotal = null;
    var $order_tax = null;
    var $order_tax_ext = null;
    var $order_shipping = null;
    var $order_payment = null;
    var $order_discount = null;
    var $currency_code = null;
    var $currency_code_iso = null;
    var $order_status = null;
    var $order_date = null;
    var $order_m_date = null;
    var $shipping_method_id = null;
    var $payment_method_id = null;
    var $payment_params = null;
    var $payment_params_data = null;
    var $ip_address = null;
    var $order_add_info = null;
    
    var $f_name = null;
    var $l_name = null;
    var $firma_name = null;
    var $email = null;
    var $street = null;
    var $zip = null;
    var $city = null;
    var $state = null;
    var $country = null;
    var $phone = null;
    var $fax = null;
    var $title = null;

    var $d_f_name = null;
    var $d_l_name = null;
    var $d_firma_name = null;
    var $d_street = null;
    var $d_zip = null;
    var $d_city = null;
    var $d_state = null;
    var $d_country = null;
    var $d_phone = null;
    var $d_title = null;
    var $pdf_file = null;
    var $order_hash = null;
    var $file_hash = null;
    var $file_stat_downloads = null;
    var $order_custom_info = null;

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_orders', 'order_id', $_db );
    }

    function getAllItems() {
        if (!isset($this->items)){
            $query = "SELECT OI.*, P.product_thumb_image as thumb_image FROM `#__jshopping_order_item` as OI left join #__jshopping_products as P on OI.product_id=P.product_id
                      WHERE OI.order_id = '".$this->_db->getEscaped($this->order_id)."'";
            $this->_db->setQuery($query);
            $this->items = $this->_db->loadObjectList();
        }
        return $this->items;
    }
    
    function getWeightItems(){
        $items = $this->getAllItems();
        $weight = 0;
        foreach($items as $row){
            $weight += $row->product_quantity * $row->weight;
        }
    return $weight;
    }

    function getHistory() {
        $lang = &JSFactory::getLang();
        $query = "SELECT history.*, status.*, status.`".$lang->get('name')."` as status_name  FROM `#__jshopping_order_history` AS history
                  INNER JOIN `#__jshopping_order_status` AS status ON history.order_status_id = status.status_id
                  WHERE history.order_id = '" . $this->_db->getEscaped($this->order_id) . "'
                  ORDER BY history.status_date_added";
        $this->_db->setQuery($query);        
        return $this->_db->loadObjectList();
    }

    function getStatus() {
        $lang = &JSFactory::getLang();
        $query = "SELECT `".$lang->get('name')."` as name FROM `#__jshopping_order_status` WHERE status_id = '" . $this->_db->getEscaped($this->order_status) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function copyDeliveryData(){    
        $this->d_title = $this->title;
        $this->d_f_name = $this->f_name;
        $this->d_l_name = $this->l_name;
        $this->d_firma_name = $this->firma_name;
        $this->d_street = $this->street;
        $this->d_zip = $this->zip;
        $this->d_city = $this->city;
        $this->d_state = $this->state;
        $this->d_country = $this->country;
        $this->d_phone = $this->phone;        
    }

    function getOrdersForUser($id_user) {
        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang(); 
        $query = "SELECT orders.*, order_status.`".$lang->get('name')."` as status_name, COUNT(order_item.order_id) AS count_products
                  FROM `#__jshopping_orders` AS orders
                  INNER JOIN `#__jshopping_order_status` AS order_status ON orders.order_status = order_status.status_id
                  INNER JOIN `#__jshopping_order_item` AS order_item ON order_item.order_id = orders.order_id
                  WHERE orders.user_id = '" . $db->getEscaped($id_user) . "'
                  GROUP BY order_item.order_id
                  ORDER BY orders.order_date DESC";
        $db->setQuery($query);
        return $db->loadObjectList();
    }

    /**
    * Next order id    
    */
    function getLastOrderId() {
        $db =& JFactory::getDBO(); 
        $query = "SELECT MAX(orders.order_id) AS max_order_id FROM `#__jshopping_orders` AS orders";
        $db->setQuery($query);
        return $db->loadResult() + 1;
    }
    
    function generateNextOrderNumber(){
        $db =& JFactory::getDBO(); 
        $query = "SELECT MAX(order_number) AS end_number FROM `#__jshopping_orders`";
        $db->setQuery($query);
        $end_number = $db->loadResult();
        $next = intval($end_number)+1;
        $number = outputDigit($next, 8);        
        return $number;
    }

    /**
    * save name pdf from order
    */
    function insertPDF() {
        $query = "UPDATE `#__jshopping_orders` SET pdf_file = '".$this->_db->getEscaped($this->pdf_file)."' WHERE order_id = '".$this->_db->getEscaped($this->order_id)."'";
        $this->_db->setQuery($query);
        $this->_db->query();
    }
    
    function getFilesStatDownloads(){
        if ($this->file_stat_downloads == "") return array();
        return unserialize($this->file_stat_downloads);
    }
    
    function setFilesStatDownloads($array){
        $this->file_stat_downloads = serialize($array);    
    }
    
    function getTaxExt(){
        if ($this->order_tax_ext == "") return array();
        return unserialize($this->order_tax_ext);
    }
    
    function setTaxExt($array){
        $this->order_tax_ext = serialize($array);    
    }
    
    function getPaymentParamsData(){
        if ($this->payment_params_data == "") return array();
        return unserialize($this->payment_params_data);
    }
    
    function setPaymentParamsData($array){
        $this->payment_params_data = serialize($array);    
    }
    
}
?>